package com.loafle.overflow.crawler.redis;

import com.loafle.overflow.crawler.Crawler;
import com.loafle.overflow.crawler.config.Config;
import redis.clients.jedis.Jedis;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by geek on 2017-04-12.
 */
public class RedisCralwer extends Crawler {
    private Jedis jedis;

    private static final Logger LOGGER = Logger.getLogger(RedisCralwer.class.getName());

    public RedisCralwer() {

    }

    @Override
    public Object getInternal(Config c) throws Exception {
        LOGGER.log(Level.INFO ,"getInternal call");
        //접속

        Map<String, Object> re = collectMetric("192.168.1.215", (short) 6379, "","ALL");

        return re;
    }

    protected Map<String, Object> collectMetric(String ip, short port, String authpw ,String category ) {
        Jedis jedis = new Jedis(ip, port,false);
        String t = jedis.set("AUTH", authpw);
        String dd = jedis.info(category);

        // 파싱
        Map<String, Object> re = parseToMap(dd);

        System.out.println("re : "+re);
        //연결 해제
        jedis.close();
        //데이터 출력
        return re;
    }

    private Map<String, Object> parseToMap(String source) {
        String[] categorys = source.split("\r\n\r\n");
        Map<String, Object> result = new HashMap<String, Object>();

        for (String category : categorys) {
            if (category.length() == 0) {
                continue;
            }
            Map<String, String> sm = new HashMap<String,String>();
            String[] lines = category.split("\r\n");

            int idx = 0;
            for (String line : lines) {
                if (idx == 0) {
                    idx++;
                    continue;
                }

                if (line.length() == 0) {
                    continue;
                }

                String[] items = line.split(":");

                if (items.length != 0&& items.length > 1) {
                    sm.put(items[0], items[1]);
                }
            }
            String[] ca = lines[0].split(" ");

            result.put(ca[1], sm);
        }
        return result;
    }
}
